diff -NaurdbB -xCVS lsqrms-2.0.4b.old/src/main.c lsqrms-2.0.4b/src/main.c
--- lsqrms-2.0.4b.old/src/main.c	Wed Apr 16 18:33:17 EDT 2003
+++ lsqrms-2.0.4b/src/main.c	Sun Feb 24 22:49:49 EST 2008
@@ -366,99 +709,244 @@
 	 }
  }
  /* Use substitution matrix over here: */
- for(i=0;i<rows;i++) {
-	for(j=0;j<cols;j++) {
-		if( a_que[i] == a_tar[j] ) s[i][j] = 1.0; /* primitive! */
-		else s[i][j] = 0.0;                       /* primitive! */
-/* blossom62 enhancement, not always good
-        tempval = blossom62(a_que[i],a_tar[j]);   
-		s[i][j] += tempval;
-*/
+  for (i=0; i<rows; i++) {
+    for(j=0; j<cols; j++) {
+      if (use_identity || use_blosum62 || use_blosum62_pos) {
+	if (a_que[i] == a_tar[j])
+	  ss[i][j] = 1.0; /* primitive! */
+	else
+	  ss[i][j] = 0.0; /* primitive! */
+	if (use_blosum62 || use_blosum62_pos) {
+	  /* blosum62 enhancement, not always good */
+	  tempval = blosum62(a_que[i],a_tar[j],altered,use_carbonyl);
+	  ss[i][j] += tempval;
+	  if (use_blosum62_pos)
+	    ss[i][j] += 8;
+	} else if (use_carbonyl) {
+	  if (isascii(a_que[i]) != isascii(a_tar[j]))
+	    ss[i][j] = -1000;
+	  else if (! isascii(a_que[i])) {
+	    if (isupper(toascii(a_que[i])) != isupper(toascii(a_tar[j])))
+	      ss[i][j] = -1000;
+	    else if (isalpha(toascii(a_que[i])) !=
+		     isalpha(toascii(a_tar[j])))
+	      ss[i][j] = -1000;
+	  } else if (isupper(a_que[i]) != isupper(a_tar[j]))
+	    ss[i][j] = -1000;
+	}
+      } else if (use_nussinov) {
+	ss[i][j] = 0.0;
+	tempval = nussinov(a_que[i],a_tar[j],altered,use_carbonyl);
+	ss[i][j] += tempval;
+      } else if (use_gonnet_p) {
+	ss[i][j] = 0.0;
+	tempval = gonnet_p(a_que[i],a_tar[j],altered,use_carbonyl);
+	ss[i][j] += tempval;
+      } else if (use_pam120_p) {
+	ss[i][j] = 0.0;
+	tempval = pam120_p(a_que[i],a_tar[j],altered,use_carbonyl);
+	ss[i][j] += tempval;
+      } else {
+	ss[i][j] = 0.0;
+	tempval = glyproaln(a_que[i],a_tar[j],altered,use_carbonyl);
+	ss[i][j] += tempval;
 	}
  }
- ret_val = dyn_pr_n2(s, iOpnPen, iExtPen, jOpnPen, jExtPen, rows, cols,
-                     SS,  TrRow,   TrCol, &iOverallMax, &jOverallMax); 
+  }
+
+  printf("Have %d rows, %d cols\n", rows, cols);
+  fflush(NULL);
+
+  (void)dyn_pr_n2(ss, iOpnPen, iExtPen, jOpnPen, jExtPen, r_num_que, r_num_tar,
+		  rows, cols, SS, TrRow, TrCol, &iOverallMax, &jOverallMax); 
  nbrks = -1;
  nEqPairs_sav = nEqPairs;
- nEqPairs = TrMat2Equivalences (rows,cols,TrRow,TrCol,
-	                            iOverallMax,jOverallMax,iina,jinb,&nbrks);
-
- for(i=0;i<=MAXSEQ;i++) {
+  nEqPairs_old = nEqPairs;
+  nEqPairs = TrMat2Equivalences(rows,cols,TrRow,TrCol,
+				iOverallMax,jOverallMax,
+				iina,jinb,&nbrks);
+  printf("nEqPairs: %d\n", nEqPairs); fflush(NULL);
+  nbrks_sav = nbrks;
+  nbrks_old = nbrks;
+  for (i=0; i<=MAXSEQ; i++) {
    iina_sav[i] = iina[i];
+    iina_old[i] = iina[i];
    jinb_sav[i] = jinb[i];
+    jinb_old[i] = jinb[i];
  }
 
- tempval = MIN2( (double)rows, (double)cols);
- PID = (double)nEqPairs/( tempval );
+  tempval = MIN((double)rows, (double)cols);
+  PEQUIV = (double)nEqPairs/(tempval);
 
- if(PID > 0.1) { /* It makes sense to start with eq.pairs from sequence alignment: */
+  if ((single_ok && (nEqPairs >= tempval) && (nEqPairs >= 4)) ||
+      ((nEqPairs > 2) && (lsq || (PEQUIV >= 0.3)) &&
+       ((nEqPairs > 8) || (! use_carbonyl)))) {
+    /* It makes sense to start with eq.pairs from sequence alignment: */
 
- str1 = (CoordType *) malloc(nEqPairs * sizeof(CoordType));
- str2 = (CoordType *) malloc(nEqPairs * sizeof(CoordType));
+    if (use_carbonyl)
+      nEqPairs = 4*(floor((double)nEqPairs/4.0));
 
- for(i=0;i<nEqPairs;i++) {
-   str1[i].x = x_que[1][iina[i]-1]; str2[i].x = x_tar[1][jinb[i]-1];
-   str1[i].y = x_que[2][iina[i]-1]; str2[i].y = x_tar[2][jinb[i]-1];
-   str1[i].z = x_que[3][iina[i]-1]; str2[i].z = x_tar[3][jinb[i]-1];		
+    str1 = (CoordType *)malloc(nEqPairs * sizeof(CoordType));
+    if (!str1) {
+      fprintf(stderr, "main: Allocation failed!\n");
+      exit(1);
+    }
+    str2 = (CoordType *)malloc(nEqPairs * sizeof(CoordType));
+    if (!str2) {
+      fprintf(stderr, "main: Allocation failed!\n");
+      exit(1);
  }
 
- RMS = bestfit(U, T, str1, str2, nEqPairs); 
- printf("PID, RMS, eq.pairs (from sequence alignment) = %f %f %d\n",PID*100,RMS,nEqPairs);
+    for (i=0;i<nEqPairs;i++) {
+      str1[i].x = x_que[1][iina[i]-1];
+      str2[i].x = x_tar[1][jinb[i]-1];
 
- ret_val = rotrans(x_que, rows, U, T);
+      str1[i].y = x_que[2][iina[i]-1];
+      str2[i].y = x_tar[2][jinb[i]-1];
 
- if( RMS < RMSmin ) {
-   RMSmin = RMS;
+      str1[i].z = x_que[3][iina[i]-1];
+      str2[i].z = x_tar[3][jinb[i]-1];
+    }
+
+    RMS = bestfit(U, T, str1, str2, nEqPairs);
+    if (RMS > 0.01)
+      quality = fsqrt(nEqPairs)/RMS;
+    else
+      quality = 100*fsqrt(nEqPairs);
+    printf("PEQUIV, RMS, eq.pairs, quality (from seq align) = %f %f %d %f\n",
+	   PEQUIV*100,RMS,nEqPairs,quality);
+    quality_max = quality;
+    quality_sav = quality;
+    quality_old = quality;
+    RMSsav = RMS;
+    RMSold = RMS;
    for(i=0; i<rows; i++) {
      x_que_sav[1][i] = x_que[1][i]; 
      x_que_sav[2][i] = x_que[2][i]; 
      x_que_sav[3][i] = x_que[3][i]; 
-   }
+      x_que_old[1][i] = x_que[1][i];
+      x_que_old[2][i] = x_que[2][i];
+      x_que_old[3][i] = x_que[3][i];
  }
- free( (RELEASE) (str1) );
- free( (RELEASE) (str2) );
+
+    (void)rotrans(x_que, rows, U, T);
+    
+    if (RMS < RMSmin)
+      RMSmin = RMS;
+    free((RELEASE)(str1));
+    free((RELEASE)(str2));
  } else { /* PID < threshold */
-   printf("PID is %f, rather low to start with SeqAli Eq. pairs\n",PID*100);
+    printf("PEQUIV is %f, rather low to start with %d SeqAli Eq. pairs\n",
+	   PEQUIV*100, nEqPairs);
  }
 
  free_iVector(iina,0, MAXSEQ);
  free_iVector(jinb,0, MAXSEQ);
 
-/* END OF THE INITIAL STARTING POINT */
+  fflush(NULL);
 
- if(!lsq) {
- do{ iter++;    /* START OF MAIN ITERATION CYCLE: */
-/* CHECK COORDINATES:
-    stream = fopen( "coordchk.dat", "a" );
-	if( stream == NULL )
-	   printf( "Couldn't open file coordchk.dat\n" );
-	else   {
-    fprintf( stream, "Iteration # %d: \n",iter);
-    fprintf( stream, "Query: \n");
-	for(i=0;i<rows;i++) {
-	  fprintf( stream, "%f %f %f\n", x_que[1][i], x_que[2][i], x_que[3][i]);
+  /* END OF THE INITIAL STARTING POINT */
+  
+  if (!lsq) {
+    for (j=0; j<=(cols-1); j++) {
+      if (altered && isascii(a_tar[j]) && (! isalpha(a_tar[j]))) {
+	jOpnPen[j] = 20;
+	jExtPen[j] = 20;
+      } else {
+	jOpnPen[j] = 0;
+	jExtPen[j] = 0;
 	}
-    fprintf( stream, "Target: \n");
-	for(i=0;i<cols;i++) {
-	  fprintf( stream, "%f %f %f\n", x_tar[1][i], x_tar[2][i], x_tar[3][i]);
 	}
-    fclose( stream );
+    for (i=0; i<=(rows-1); i++) {
+      if (altered && isascii(a_que[i]) && (! isalpha(a_que[i]))) {
+	iOpnPen[i] = 20;
+	iExtPen[i] = 20;
+      } else {
+	iOpnPen[i] = 0;
+	iExtPen[i] = 0;
 	}
-*/
+    }
+
+    do {
+      iter++;    /* START OF MAIN ITERATION CYCLE: */
+      /* CHECK COORDINATES: */
+      /*      stream = fopen( "coordchk.dat", "a" ); */
+      /*      if (stream == NULL) */
+      /*        printf("Couldn't open file coordchk.dat\n" ); */
+      /*      else { */
+      /*        fprintf(stream, "Iteration # %d: \n",iter); */
+      /*        fprintf(stream, "Query: \n"); */
+      /*        for (i=0; i<rows; i++) { */
+      /* 	 fprintf(stream, "%f %f %f\n", */
+      /* 		 x_que[1][i], x_que[2][i], x_que[3][i]); */
+      /*        } */
+      /*        fprintf(stream, "Target: \n"); */
+      /*        for (i=0; i<cols; i++) { */
+      /* 	 fprintf(stream, "%f %f %f\n", */
+      /* 		 x_tar[1][i], x_tar[2][i], x_tar[3][i]); */
+      /*        } */
+      /*        fclose(stream); */
+      /*      } */
+
+      again = 0;
+      again2 = 0;
+      sav_updated = 0;
+      increased_gap_penalties = 0;
+     
  iina     = iVector(0,MAXSEQ);
  jinb     = iVector(0,MAXSEQ);
 
- for(i=0;i<=MAXSEQ;i++) {
+      for (i=0; i<=MAXSEQ; i++) {
    iina[i] = -1;
    jinb[i] = -1;
  }
 
- for(i=0;i<=rows-1;i++) {
-	for(j=0;j<=cols-1;j++) {
-		s[i][j]     = sqrt( (x_que[1][i]-x_tar[1][j])*(x_que[1][i]-x_tar[1][j]) +
+      for (i=0; i<=rows-1; i++) {
+	for (j=0;j<=cols-1;j++) {
+	  dd[i][j] = (SQR(x_que[1][i]-x_tar[1][j]) +
+			SQR(x_que[2][i]-x_tar[2][j]) +
+			SQR(x_que[3][i]-x_tar[3][j]));
+	  ss[i][j] = 0;
+	  if (use_carbonyl) {
+	    tempval = check_carbonyl(a_que[i],a_tar[j]);
+	    ss[i][j] += tempval;
+	  }
+	  if (ss[i][j] == 0) {
+	    ss[i][j] = dd[i][j];
+	    if (use_min_thresh && (ss[i][j] < L_THRESH_SQR)) {
+	      if (ss[i][j] <= L_MIN_SQR)
+		ss[i][j] = 0;
+	      else {
+		ss[i][j] =
+		  (sqrt(ss[i][j]) - L_MIN)*(L_THRESH/(L_THRESH-L_MIN));
+		if (ss[i][j] > 0) /* in case of roundoff error */
+		  ss[i][j] *= ss[i][j];
+		else
+		  ss[i][j] = 0;
+	      }
+	    } else if (use_min_thresh2 && (ss[i][j] < L_THRESH2_SQR)) {
+	      if (ss[i][j] <= L_MIN_SQR)
+		ss[i][j] = 0;
+	      else {
+		ss[i][j] =
+		  (sqrt(ss[i][j]) - L_MIN)*(L_THRESH2/(L_THRESH2-L_MIN));
+		if (ss[i][j] > 0) /* in case of roundoff error */
+		  ss[i][j] *= ss[i][j];
+		else
+		  ss[i][j] = 0;
+	      }
+	    }
+	    ss[i][j] = 20.0/(1.0 + (ss[i][j]/25.0));
+	    dd[i][j] = sqrt(dd[i][j]);
+	    
+	    /* ss[i][j] =
+	       sqrt((x_que[1][i]-x_tar[1][j])*(x_que[1][i]-x_tar[1][j]) +
 			                (x_que[2][i]-x_tar[2][j])*(x_que[2][i]-x_tar[2][j]) +
-			                (x_que[3][i]-x_tar[3][j])*(x_que[3][i]-x_tar[3][j]) );
-		s[i][j] = 20.0 / ( 1.0 + SQR(s[i][j]/5.0) );
+	       (x_que[3][i]-x_tar[3][j])*(x_que[3][i]-x_tar[3][j]));
+	       
+		 ss[i][j] = 20.0 / ( 1.0 + SQR(ss[i][j]/5.0) ); */
+	  }
+
 		SS[i][j]    = 0.0;
         TrRow[i][j] = 0.0;
 		TrCol[i][j] = 0.0;
